zoukankan      html  css  js  c++  java
  • POJ2282:The Counting Problem(数位DP)

    Description

    Given two integers a and b, we write the numbers between a and b, inclusive, in a list. Your task is to calculate the number of occurrences of each digit. For example, if a = 1024 and b = 1032, the list will be
    1024 1025 1026 1027 1028 1029 1030 1031 1032

    there are ten 0's in the list, ten 1's, seven 2's, three 3's, and etc.

    Input

    The input consists of up to 500 lines. Each line contains two numbers a and b where 0 < a, b < 100000000. The input is terminated by a line `0 0', which is not considered as part of the input.

    Output

    For each pair of input, output a line containing ten numbers separated by single spaces. The first number is the number of occurrences of the digit 0, the second is the number of occurrences of the digit 1, etc.

    Sample Input

    1 10
    44 497
    346 542
    1199 1748
    1496 1403
    1004 503
    1714 190
    1317 854
    1976 494
    1001 1960
    0 0
    

    Sample Output

    1 2 1 1 1 1 1 1 1 1
    85 185 185 185 190 96 96 96 95 93
    40 40 40 93 136 82 40 40 40 40
    115 666 215 215 214 205 205 154 105 106
    16 113 19 20 114 20 20 19 19 16
    107 105 100 101 101 197 200 200 200 200
    413 1133 503 503 503 502 502 417 402 412
    196 512 186 104 87 93 97 97 142 196
    398 1375 398 398 405 499 499 495 488 471
    294 1256 296 296 296 296 287 286 286 247
    
     
    题意:求出区间内0~9的个数
    思路:dp[i][j],代表长度为i的数字里面共有几个j
     
     
    #include <stdio.h>
    #include <string.h>
    #include <algorithm>
    using namespace std;
    
    __int64 dp[9] = {1,10,100,1000,10000,100000,1000000,10000000,100000000};
    //只考虑以某个数开头,例如9XXX,不算XXX里的9,共头1000个9
    __int64 solve(__int64 n,__int64 pos)
    {
        __int64 left,m,sum = 0;
        __int64 i;
        for(i = 1; i<9; i++)
        {
            left = n/dp[i];//以123为例,第一次循环求出得出12
            if(!pos)
                left--;
            sum+=left*dp[i-1];//12后面的数,每种都只有1个
            m = (n%dp[i]-n%dp[i-1])/dp[i-1];//求出12后面的数确切是什么
            if(m>pos)
                sum+=dp[i-1];//因为m>pos,所以pos的数目即为m后面所有这个数字的和,而m是第i位,所以总和加上dp[i-1]
            else if(m==pos)
                sum+=n%dp[i-1]+1;//求出m后的数字是几,总数还要加上m本身的个数
            if(n<dp[i])//退出条件
                break;
        }
        return sum;
    }
    
    int main()
    {
        __int64 n,m;
        __int64 i;
        while(~scanf("%I64d%I64d",&n,&m),n+m)
        {
            if(n>m)
                swap(n,m);
            printf("%I64d",solve(m,0)-solve(n-1,0));
            for(i = 1; i<=9; i++)
                printf(" %I64d",solve(m,i)-solve(n-1,i));
            printf("
    ");
        }
    
        return 0;
    }
    
  • 相关阅读:
    【LeetCode-树】找树左下角的值
    【LeetCode-贪心】合并区间
    MongoDB3.6版本新增特性
    MongoDB initial sync过程
    MongoDB3.4版本新增特性
    保险配置原则
    MongoDB批量操作时字段为null时没有入库
    Kafka消费者没有收到通知的分析
    Git分支的管理
    NoSQLBooster如何MongoDB的部分文档从一个集合拷贝到另外一个集合中
  • 原文地址:https://www.cnblogs.com/james1207/p/3262752.html
Copyright © 2011-2022 走看看